#include <iostream>
#include <vector>

using namespace std;

int t = 0;
vector<int> num;
vector<int> low;

vector<int> s;
vector<bool> in_s;

void dfs(int u, vector< vector<int> >& graf) {
	low[u] = num[u] = ++t;
	s.push_back(u);
	in_s[u] = true;

	for(int v : graf[u])
		if(num[v] == 0) {
			dfs(v, graf);
			low[u] = min(low[u], low[v]);
		}
		else if(in_s[v])
			low[u] = min(low[u], num[v]);

	if(low[u] == num[u]) {
		int tu = -1;
		while(tu != u) {
			tu = s.back();
			in_s[tu] = false;
			s.pop_back();
			cout << tu << ' ';
		}
		cout << '\n';
	}
}

int main() {
	int n, m;
	cin >> n >> m;

	vector< vector<int> > graf(n);
	for(int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;

		graf[u].push_back(v);
	}

	num = vector<int>(n);
	low = vector<int>(n);
	in_s = vector<bool>(n);
	for(int i = 0; i < n; i++)
		if(num[i] == 0)
			dfs(i, graf);

	return 0;
}
